package com.kalyshev.yan.cabinet.controller;

import com.kalyshev.yan.cabinet.model.Cabinet;
import com.kalyshev.yan.computer.model.Computer;

import java.util.ArrayList;
import java.util.List;

public class CabinetDto {
    private Long id;
    private String number;
    private List<Long> computerIds;
    public CabinetDto() {}
    public CabinetDto(Cabinet cabinet) {
        this.id = cabinet.getId();
        this.number = cabinet.getNumber();
        if (cabinet.getComputers() == null) {
            this.computerIds = new ArrayList<>();
        } else {
            this.computerIds = new ArrayList<>();
            List<Computer> computers = cabinet.getComputers();
            for (Computer computer : computers) {
                computerIds.add(computer.getId());
            }
        }
    }
    public Long getId() { return this.id; }
    public void setId(Long id) { this.id = id; }
    public String getNumber() { return this.number; }
    public void setNumber(String number) { this.number = number; }
    public List<Long> getComputerIds() { return this.computerIds; }
    public void setComputerIds(List<Long> computerIds) { this.computerIds = computerIds; }
}
