package com.kalyshev.yan.cabinet.model;

import com.kalyshev.yan.computer.model.Computer;

import javax.persistence.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

@Entity
@Table(name = "cabinet")
public class Cabinet {
    @Id
    @GeneratedValue
    private Long id;
    private String number;
    @OneToMany(cascade = {CascadeType.MERGE})
    private List<Computer> computers;

    public Cabinet() {
    }
    public Cabinet(String number) {
        this.number = number;
    }
    public Long getId() {
        return id;
    }
    public String getNumber() {
        return number;
    }
    public void setNumber(String number) {
        this.number = number;
    }
    public List<Computer> getComputers() {
        return computers;
    }
    public void addComputer(Computer computer){
        if (computers == null){
            this.computers = new ArrayList<>();
        }
        if (!computers.contains(computer)) {
            this.computers.add(computer);
            computer.setCabinet(this);
        }
    }
    public void removeComputer(Computer computer){
        if (computers.contains(computer))
            this.computers.remove(computer);
    }

    @Override
    public boolean equals(Object o) {
        if (this == o)
            return true;
        if (!(o instanceof Cabinet))
            return false;
        Cabinet cabinet = (Cabinet) o;
        return Objects.equals(id, cabinet.id) && Objects.equals(this.number, cabinet.number);
    }
    @Override
    public int hashCode() {
        return Objects.hash(id);
    }
    @Override
    public String toString() {
        return "Cabinet{" +
                "id=" + id +
                ", number='" + number + '\'' +
                '}';
    }
}
