package com.kalyshev.yan.computer.repository;

import com.kalyshev.yan.computer.model.Computer;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface ComputerRepository extends JpaRepository<Computer, Long> {
    @Query(value = "select * from Computer where (\"ID\" = :id or :id is Null) and " +
            "(\"MODEL_NAME\" = :modelName or :modelName is Null) and " +
            "(\"SERIAL_NUM\" = :serialNum or :serialNum is Null) and " +
            "(\"MONITOR_ID\" = :monitorId or :monitorId is Null) and " +
            "(\"CABINET\" = :cabinetId or :cabinetId is Null)", nativeQuery = true)
    public List<Computer> findFilteredComputers(@Param("id") Long id,
                                                @Param("modelName") String modelName,
                                                @Param("serialNum") String serialNum,
                                                @Param("monitorId") Long monitorId,
                                                @Param("cabinetId") Long cabinetId);

    @Query(value = "select * from Computer where \"MONITOR_ID\" = :monitorId", nativeQuery = true)
    public Computer findComputerByMonitor(@Param("monitorId") Long monitorId);

    @Modifying
    @Query(value = "update Computer set \"MONITOR_ID\" = null", nativeQuery = true)
    public void removeAllComputerMonitorRelations();

//    @Query(value = "update Computer where id in :computerIds set cabinet_id = null")
//    public void deleteRelationsWithCabinets(@Param("computerIds") Collection<Long> computerIds);
}
